class PcTemplates
{
  static initialize()
  {
    this.resources = [];
  }

  static getTemplate(paper, poses, layout)
  {
    let res =
      {
        size:
        {
          width:0,
          height:0
        },
        poses:[]
      };

    let normalPoses = [
      {x:56, y:56, width:516, height:516},
      {x:628, y:56, width:516, height:516},
      {x:56, y:628, width:516, height:516},
      {x:628, y:628, width:516, height:516}
    ];

    let normalPoses5x15 = [
      {x:42, y:42, width:516, height:344},
      {x:42, y:417, width:516, height:344},
      {x:42, y:792, width:516, height:344},
      {x:42, y:1167, width:516, height:344}
    ];

    let normalPoses15x15 = [
      {x:84, y:84, width:774, height:774},
      {x:942, y:84, width:774, height:774},
      {x:84, y:942, width:774, height:774},
      {x:942, y:942, width:774, height:774}
    ];

    let fullPoses10x15 = [
      {x:0, y:0, width:600, height:900},
      {x:600, y:0, width:600, height:900},
      {x:0, y:900, width:600, height:900},
      {x:600, y:900, width:600, height:900}
    ];

    let fullPoses15x10 = [
      {x:0, y:0, width:900, height:600},
      {x:900, y:0, width:900, height:600},
      {x:0, y:600, width:900, height:600},
      {x:900, y:600, width:900, height:600}
    ];

    let fullPoses5x15 = [
      {x:0, y:0, width:600, height:450},
      {x:0, y:450, width:600, height:450},
      {x:0, y:900, width:600, height:450},
      {x:0, y:1350, width:600, height:450}
    ];

    let fullPoses15x15 = [
      {x:0, y:0, width:900, height:900},
      {x:0, y:900, width:900, height:900},
      {x:900, y:0, width:900, height:900},
      {x:900, y:900, width:900, height:900}
    ];

    switch (paper)
    {
      case "10x15" :
        res.size.width=1200; res.size.height=1800;
        switch (poses)
        {
          case "1" :
            switch (layout)
            {
              case "normal" : res.poses = [{x:56, y:56, width:1088, height:1088}]; break;
              case "captur" : res.poses = [{x:0, y:0, width:1200, height:1200}]; break;
              case "20minutes" : res.poses = [{x:324, y:101, width:833, height:1461}]; break;
              case "vuitton" : res.poses = [{x:63, y:63, width:1074, height:1346}]; break;
              case "feteinfrance" : res.poses = [{x:142, y:142, width:916, height:1095}]; break;
              default : res.poses = [{x:0, y:0, width:1200, height:1800}];
            }
            break;
          case "1-4" : layout=="normal" ? res.poses = normalPoses.slice(0,1) : res.poses = fullPoses10x15.slice(0,1); break;
          case "2-4" : layout=="normal" ? res.poses = normalPoses.slice(0,2) : res.poses = fullPoses10x15.slice(0,2); break;
          case "3-4" : layout=="normal" ? res.poses = normalPoses.slice(0,3) : res.poses = fullPoses10x15.slice(0,3); break;
          case "4-4" : layout=="normal" ? res.poses = normalPoses.slice(0,4) : res.poses = fullPoses10x15.slice(0,4); break;
        }
        break;
      case "15x10" :
          res.size.width=1800; res.size.height=1200;
          switch (poses)
          {
            case "1" : layout=="normal" ? res.poses = [{x:56, y:56, width:1088, height:1088}] : res.poses = [{x:0, y:0, width:1800, height:1200}]; break;
            case "1-4" : layout=="normal" ? res.poses = normalPoses.slice(0,1) : res.poses = fullPoses15x10.slice(0,1); break;
            case "2-4" : layout=="normal" ? res.poses = normalPoses.slice(0,2) : res.poses = fullPoses15x10.slice(0,2); break;
            case "3-4" : layout=="normal" ? res.poses = normalPoses.slice(0,3) : res.poses = fullPoses15x10.slice(0,3); break;
            case "4-4" : layout=="normal" ? res.poses = normalPoses.slice(0,4) : res.poses = fullPoses15x10.slice(0,4); break;
          }
          break;
      case "5x15" :
        res.size.width=600; res.size.height=1800;
        switch (poses)
        {
          case "1" : res.poses = [{x:0, y:0, width:600, height:1800}]; break;
          case "1-4" : layout=="normal" ? res.poses = normalPoses5x15.slice(0,1) : res.poses = fullPoses5x15.slice(0,1); break;
          case "2-4" : layout=="normal" ? res.poses = normalPoses5x15.slice(0,2) : res.poses = fullPoses5x15.slice(0,2); break;
          case "3-4" : layout=="normal" ? res.poses = normalPoses5x15.slice(0,3) : res.poses = fullPoses5x15.slice(0,3); break;
          case "4-4" : layout=="normal" ? res.poses = normalPoses5x15.slice(0,4) : res.poses = fullPoses5x15.slice(0,4); break;
        }
        break;
      case "15x15" :
          res.size.width=1800; res.size.height=1800;
          switch (poses)
          {
            case "1" : res.poses = [{x:0, y:0, width:1800, height:1800}]; break;
            case "1-4" : layout=="normal" ? res.poses = normalPoses15x15.slice(0,1) : res.poses = fullPoses15x15.slice(0,1); break;
            case "2-4" : layout=="normal" ? res.poses = normalPoses15x15.slice(0,2) : res.poses = fullPoses15x15.slice(0,2); break;
            case "3-4" : layout=="normal" ? res.poses = normalPoses15x15.slice(0,3) : res.poses = fullPoses15x15.slice(0,3); break;
            case "4-4" : layout=="normal" ? res.poses = normalPoses15x15.slice(0,4) : res.poses = fullPoses15x15.slice(0,4); break;
          }
          break;
      case "amundi" :
          res.size.width=3791; res.size.height=3791;
          switch (poses)
          {
            case "1" : res.poses = [{x:0, y:0, width:3791, height:3791}]; break;
            case "1-4" : layout=="normal" ? res.poses = normalPoses15x15.slice(0,1) : res.poses = fullPoses15x15.slice(0,1); break;
            case "2-4" : layout=="normal" ? res.poses = normalPoses15x15.slice(0,2) : res.poses = fullPoses15x15.slice(0,2); break;
            case "3-4" : layout=="normal" ? res.poses = normalPoses15x15.slice(0,3) : res.poses = fullPoses15x15.slice(0,3); break;
            case "4-4" : layout=="normal" ? res.poses = normalPoses15x15.slice(0,4) : res.poses = fullPoses15x15.slice(0,4); break;
          }
          break;
    }

    return res;
  }

  static createThumb(shots, w, h)
  {
    var canvas = document.createElement('canvas');
    var context = canvas.getContext('2d');
    context.globalAlpha = 1;
    canvas.width = w;
    canvas.height = h;

    let shot = PcTemplates.getZoomCropCanvas(shots[0], w, h);
    context.drawImage(shot, 0, 0, w, h);
    shot = null;

    return canvas;
  }

  static createRoundRect(ctx, x, y, width, height, radius, fill, stroke)
  {
    if (typeof stroke === 'undefined') { stroke = true;}
    if (typeof radius === 'undefined') { radius = 5;}
    if (typeof radius === 'number') {
      radius = {tl: radius, tr: radius, br: radius, bl: radius};
    } else {
      var defaultRadius = {tl: 0, tr: 0, br: 0, bl: 0};
      for (var side in defaultRadius) {
        radius[side] = radius[side] || defaultRadius[side];
      }
    }
    ctx.beginPath();
    ctx.moveTo(x + radius.tl, y);
    ctx.lineTo(x + width - radius.tr, y);
    ctx.quadraticCurveTo(x + width, y, x + width, y + radius.tr);
    ctx.lineTo(x + width, y + height - radius.br);
    ctx.quadraticCurveTo(x + width, y + height, x + width - radius.br, y + height);
    ctx.lineTo(x + radius.bl, y + height);
    ctx.quadraticCurveTo(x, y + height, x, y + height - radius.bl);
    ctx.lineTo(x, y + radius.tl);
    ctx.quadraticCurveTo(x, y, x + radius.tl, y);
    ctx.closePath();
    if (fill) {
      ctx.fill();
    }
    if (stroke) {
      ctx.stroke();
    }
  }

  static create_old(paper, poses, layout, framing, color, backgroundUrl, foregroundUrl, shots)
  {
    var template = PcTemplates.getTemplate(paper, poses, layout);
    var imgBackground = PcTemplates.getResource(backgroundUrl);
    var imgForeground = PcTemplates.getResource(foregroundUrl);

    var canvas = document.createElement('canvas');
    var context = canvas.getContext('2d');
    context.globalAlpha = 1;
    canvas.width = template.size.width;
    canvas.height = template.size.height;

    context.fillStyle = color;
    context.fillRect(0, 0, template.size.width, template.size.height);

    if (imgBackground)
    {
      context.drawImage(imgBackground, 0, 0, template.size.width, template.size.height);
    }

    for (let i=0; i<template.poses.length; i++)
    {
      let ratio = template.poses[i].width / template.poses[i].height;
      let shot = PcTemplates.getZoomCropCanvas(shots[i], template.poses[i].width, template.poses[i].height);

      if (framing=="rounded" && layout=="normal")
      {
          context.save();
          this.createRoundRect(context, template.poses[i].x, template.poses[i].y, template.poses[i].width, template.poses[i].height, 35, true, false);
          context.clip();
          context.drawImage(shot, template.poses[i].x, template.poses[i].y, template.poses[i].width, template.poses[i].height);
          context.restore();
      }
      else {
        context.drawImage(shot, template.poses[i].x, template.poses[i].y, template.poses[i].width, template.poses[i].height);
      }

      shot = null;
    }

    if (imgForeground)
    {
      context.drawImage(imgForeground, 0, 0, template.size.width, template.size.height);
    }

    return canvas;
  }

  static create(format, color, backgroundUrl, foregroundUrl, shots)
  {
    let paper = format.paper;
    let poses = format.poses;
    let layout = format.layout;
    let framing = format.framing;
    let autocrop = format.autocrop;

    var template = PcTemplates.getTemplate(paper, poses, layout);
    var imgBackground = PcTemplates.getResource(backgroundUrl);
    var imgForeground = PcTemplates.getResource(foregroundUrl);

    var canvas = document.createElement('canvas');
    var context = canvas.getContext('2d');
    context.globalAlpha = 1;

    context.imageSmoothingEnabled=true;
    context.imageSmoothingQuality="high";

    canvas.width = template.size.width;
    canvas.height = template.size.height;

    context.fillStyle = color;
    context.fillRect(0, 0, template.size.width, template.size.height);

    if (imgBackground)
    {
      context.drawImage(imgBackground, 0, 0, template.size.width, template.size.height);
    }

    for (let i=0; i<template.poses.length; i++)
    {
      let ratio = template.poses[i].width / template.poses[i].height;
      let shot = PcTemplates.getZoomCropCanvas(shots[i], template.poses[i].width, template.poses[i].height, autocrop ? false : true);

      if (framing=="rounded" && layout=="normal")
      {
          context.save();
          this.createRoundRect(context, template.poses[i].x, template.poses[i].y, template.poses[i].width, template.poses[i].height, 35, true, false);
          context.clip();
          context.drawImage(shot, template.poses[i].x, template.poses[i].y, template.poses[i].width, template.poses[i].height);
          context.restore();
      }
      else {
        context.drawImage(shot, template.poses[i].x, template.poses[i].y, template.poses[i].width, template.poses[i].height);
      }

      shot = null;
    }

    if (imgForeground)
    {
      context.drawImage(imgForeground, 0, 0, template.size.width, template.size.height);
    }

    return canvas;
  }

  static createPhotoData(format, skin, filter, sessionShots)
  {
    var shots = [];
    var n = 0;
    if (format.animation=="boomerang" &&  sessionShots[0].frame.length>=4) n = 3;
    for (let i=0; i<sessionShots.length; i++) shots[i] = sessionShots[i].frame[n].filtered[filter.id];
    var canvas = PcTemplates.create(format, skin.color, skin.background, skin.foreground, shots);
    var data = canvas.toDataURL('image/jpeg', 0.9).replace(/^data:image\/\w+;base64,/, "");
    return data;
  }

  static createGif4Data(format, skin, filter, sessionShots, onFinished)
  {
    var shots = [];
    var canvas = []
    var gif = new GIF({workers: 2,quality: 20});

    for (let i=0; i<sessionShots.length; i++) shots[i] = sessionShots[i].frame[0].filtered[filter.id];

    for (let i=0; i<sessionShots.length; i++)
    {
      canvas[i] = PcTemplates.create(format, skin.color, skin.background, skin.foreground, [shots[i]]);
      gif.addFrame(canvas[i], {delay: 500});
    }

    gif.on('finished', (blob) => {
      var reader = new FileReader();
      reader.addEventListener("loadend", () => {
        onFinished(reader.result.replace(/^data:image\/\w+;base64,/, ""));
      });
      reader.readAsDataURL(blob);
    });

    gif.render();
  }

  static createBoomerangData(format, skin, filter, sessionShots, onFinished)
  {
    var shots = [];
    var canvas = []
    var gif = new GIF({workers: 2,quality: 20});

    for (let i=0; i<sessionShots[0].frame.length; i++)
    {
      for (let j=0; j<sessionShots.length; j++) shots[j] = sessionShots[j].frame[i].filtered[filter.id];
      canvas[i] = PcTemplates.create(format, skin.color, skin.background, skin.foreground, shots);
      let canvasRedim = document.createElement('canvas');
      canvasRedim.width = canvas[i].width/2;
      canvasRedim.height = canvas[i].height/2;
      canvasRedim.getContext('2d').drawImage(canvas[i], 0, 0, canvasRedim.width, canvasRedim.height);
      gif.addFrame(canvasRedim, {delay: 100});
    }

    gif.on('finished', (blob) => {
      var reader = new FileReader();
      reader.addEventListener("loadend", () => {
        onFinished(reader.result.replace(/^data:image\/\w+;base64,/, ""));
      });
      reader.readAsDataURL(blob);
    });

    gif.render();
  }

  static getZoomCropCanvas(canvas, w, h, applyWideCapture = true)
  {
    let canvasWidth, canvasHeight, canvasX, canvasY;
    let destW, destH, destX, destY;

    if (applyWideCapture && PcConfig.scenario.mode=="photobooth" && !PcConfig.screen.format.wideCapture && PcConfig.scenario.cameraOrientation!="portrait")
    {
      canvasWidth = Math.min(canvas.width, canvas.height);
      canvasHeight = canvasWidth;
      canvasX = (canvas.width-canvasWidth)/2;
      canvasY = 0;
    }
    else {
      canvasWidth = canvas.width;
      canvasHeight = canvas.height;
      canvasX = 0;
      canvasY = 0;
    }

    let dRatio = w / h;
    let cRatio = canvasWidth / canvasHeight;

    if (dRatio<cRatio)
    {
      destH = canvasHeight;
      destW = canvasHeight*dRatio;
      destY = canvasY ;
      destX = canvasX + (canvasWidth-destW)/2;
    }
    else {
      destW = canvasWidth;
      destH = canvasWidth*(1/dRatio);
      destX = canvasX;
      destY = canvasY + (canvasHeight-destH)/2;
    }

    let resCanvas = document.createElement('canvas');
    resCanvas.width = w;
    resCanvas.height = h;
    let context = resCanvas.getContext('2d');

    context.imageSmoothingEnabled=true;
    context.imageSmoothingQuality="high";

    context.drawImage(canvas, destX, destY, destW, destH, 0, 0, w, h);

    return resCanvas;
  }

  static loadResource(imgUrl, fOnLoad=null)
  {
      if (imgUrl=="") return;
      var r = {url:imgUrl, image:new Image()}
      PcTemplates.resources.push(r);

      if (fOnLoad)
      {
        PcTemplates.resources[PcTemplates.resources.length-1].image.onload = ()=>{fOnLoad(imgUrl)};
        PcTemplates.resources[PcTemplates.resources.length-1].image.onerror = ()=>{fOnLoad(imgUrl)};
      }

      PcTemplates.resources[PcTemplates.resources.length-1].image.src = imgUrl + "?x=" + Math.random();
  }

  static getResource(imgUrl)
  {
    for (let i=0; i<PcTemplates.resources.length; i++)
    {
      if (PcTemplates.resources[i].url==imgUrl)
      {
        return PcTemplates.resources[i].image;
      }
    }
    return false;
  }

}
