class PcRecordingBar extends React.Component
{
  constructor(props)
  {
    super(props);
    this.state = {opacity:0, currentTime:props.time, currentWidth:0, currentLabelPosition:0, currentLabelAlign : "left"}
    this.maxTime = props.time;
    this.tickVal = 10;
    this.label = React.createRef();
  }

  componentDidMount()
  {

  }

  start()
  {
    this.initCount()
  }

  stop()
  {
    this.resetCount();
  }


  initCount()
  {
    this.interval = setInterval(()=>{this.doCount()}, this.tickVal);
    this.setState({opacity:1});
    this.playing = true;
  }

  resetCount()
  {
    this.playing = false;
    this.state.currentTime=this.props.time;
    this.state.currentWidth=0;
    this.state.currentLabelPosition=0;
    this.state.currentLabelAlign="left";
    this.state.opacity=0;
    clearInterval(this.interval);
  }

  doCount()
  {
    if (this.props.onTick) this.props.onTick(this.maxTime - Math.ceil(this.state.currentTime));
    if (this.state.currentTime>0)
    {
      let t = this.state.currentTime-this.tickVal/1000;
      let p = (1-(t/this.props.time))*1920*PcConfig.renderSize;
      let align = "left";

      if (p-this.label.current.getWidth()>0)
      {
        p = p - this.label.current.getWidth();
        align = "right";
      }

      this.setState(
        {
          currentTime:t,
          currentWidth:1-(t/this.props.time),
          currentLabelPosition:p,
          currentLabelAlign:align
        });

        this.label.current.updateLabel(Math.ceil(this.state.currentTime));

      this.forceUpdate();
      //clearInterval(this.interval);
    }
    else
    {
        this.resetCount();
        this.props.onEndRecording();
    }
  }

  render()
  {
    return e("div",
      {
        className:"pcrecordingbar",
        style:
        {
          position:"absolute",
          width:this.props.width,
          height:this.props.height,
          opacity:this.state.opacity
        }
      },
      e("div",
      {
        className:"pcrecordingbar-bg",
        style:
        {
          position:"absolute",
          width:"100%",
          height:"100%",
          backgroundColor:this.props.backgroundColor,
          opacity:0.5
        }
      }),
      e("div",
      {
        className:"pcrecordingbar-fg",
        style:
        {
          position:"absolute",
          width:this.state.currentWidth*100 + "%",
          height:"100%",
          backgroundColor:this.props.backgroundColor,
          opacity:1
        }
      }),
      e(PcLabel,
      {
        ref:this.label,
        label:Math.ceil(this.state.currentTime) + "",
        x:this.state.currentLabelPosition,
        y:0,
        spacingH:20*PcConfig.renderSize,
        height:"100%",
        fontSize:PcConfig.scenario.fontSizeSmall,
        color: this.props.textColor,
        halign : this.state.currentLabelAlign,
        showDelay:"0,1s"
      })
    );
  }

}
