class PcSlider extends React.Component
{
  componentDidMount()
  {
    $('.mainslider_' + this.props.name).slick(
        {
          infinite: true,
          slidesToShow: 1,
          slidesToScroll: 1,
          centerMode: true,
          variableWidth: true,
          swipeToSlide: true,
          swipeAngleOffset: 90,
          speed:200,
          cssEase:"ease-out",
          focusOnSelect: true,
          asNavFor: '.navslider_' + this.props.name
        });

    $('.navslider_' + this.props.name).slick(
        {
          infinite: false,
          slidesToShow: 8,
          slidesToScroll: 1,
          centerMode: false,
          variableWidth: false,
          draggable: false,
          speed:200,
          cssEase:"ease-out",
          focusOnSelect: true,
          asNavFor: '.mainslider_' + this.props.name
        });

  }

  render()
  {
    if (this.props.active)
    {
      setTimeout( ()=> {
        $('.mainslider_' + this.props.name).slick("slickGoTo", 0);
        $('.mainslider_' + this.props.name).slick("setPosition");
        $('.navslider_' + this.props.name).slick("setPosition");
      }, 10);
    }

    var mainSlides = [];
    var navSlides = [];

    for (var i=0; i<this.props.images.length; i++)
    {
      mainSlides[i] = e('div',{className:"slick-item", key:"img"+i, style:{height:this.props.height, margin:30*PcConfig.renderSize}},
                    e('img',
                      {
                        src:this.props.images[i],
                        style:
                        {
                          height:"100%",
                        }
                      }
                    )
                  );
      navSlides[i] = e('div',{className:"slick-item-nav", key:"imgnav"+i, style:{height:this.props.height/5}},
                      e('div', {style:{display:"table", margin:"auto", width:"80%", height:"80%"}},
                        e('img',
                          {
                            src:this.props.images[i],
                            style:
                            {
                              width:"100%",
                              height:"100%",
                              objectFit:"contain"
                            }
                          }
                        )
                      )
                    );
    }

    return e('div',
        {
          className:"pcslidercontainer",
          style:
          {
            position:"absolute",
            opacity:0,
            animation:PcConfig.scenario.elementsAnimationStyle,
            animationFillMode:"forwards",
            animationDelay:this.props.showDelay,
            width:this.props.width,
            height:this.props.height,
            left:this.props.x,
            top:this.props.y
          }
        },
        e('div', {className:"mainslider_"+this.props.name, width:this.props.width, height:this.props.height}, mainSlides),
        e('div', {style:{height:50*PcConfig.renderSize}}),
        e('div', {className:"navslider_"+this.props.name, width:this.props.width, height:this.props.height/5}, navSlides)
      );
  }
}
