class PcSliderFilters extends React.Component
{
  constructor(props)
  {
    super(props);

    this.reseted = false;

    this.mainSlides = [];
    for (var i=0; i<PcConfig.screen.preview.filters.length; i++) this.mainSlides[i] = React.createRef();

    this.navSlides = []
    for (var i=0; i<PcConfig.screen.preview.filters.length; i++) this.navSlides[i] = React.createRef();
  }

  reset()
  {
    if (this.reseted) return;

    $('.mainslider_' + this.props.name).slick(
        {
          infinite: false,
          slidesToShow:1,
          slidesToScroll: 1,
          centerMode: true,
          variableWidth: true,
          swipeToSlide: true,
          swipeAngleOffset: 90,
          speed:200,
          cssEase:"ease-out",
          focusOnSelect: true,
          arrows:false,
          asNavFor: '.navslider_' + this.props.name
        });

    $('.navslider_' + this.props.name).slick(
        {
          infinite: false,
          slidesToShow: PcConfig.screen.preview.filters.length,
          slidesToScroll: 1,
          centerMode: false,
          variableWidth: true,
          draggable: false,
          speed:200,
          cssEase:"ease-out",
          focusOnSelect: true,
          arrows:false,
          asNavFor: '.mainslider_' + this.props.name
        });

    $('.mainslider_' + this.props.name).on('beforeChange', (event, slick, currentSlide, nextSlide) =>
    {
      for(let i=0; i<this.mainSlides.length; i++) this.mainSlides[i].current.stop();
      this.mainSlides[nextSlide].current.start();

      PcConfig.setMemory("currentTemplate", this.mainSlides[nextSlide].current.props.template);
      PcConfig.setMemory("currentFilter", this.mainSlides[nextSlide].current.props.filter);
      PcConfig.setMemory("currentBackgrounds", this.mainSlides[nextSlide].current.props.backgrounds);
      PcConfig.setMemory("currentForegrounds", this.mainSlides[nextSlide].current.props.foregrounds);
    });


    $('.mainslider_' + this.props.name).slick("slickGoTo", 0);
    $('.mainslider_' + this.props.name).slick("setPosition");
    $('.navslider_' + this.props.name).slick("setPosition");

    this.reseted = true;
  }

  onTouchSlide(i)
  {
    $('.mainslider_' + this.props.name).slick("slickGoTo", i);
  }

  delete()
  {
    for(let i=0; i<this.mainSlides.length; i++)
    {
      if (this.mainSlides[i].current)
      {
        this.mainSlides[i].current.delete();
        this.navSlides[i].current.delete();
      }
      this.mainSlides[i] = null;
      this.navSlides[i] = null;
    }

    $('.mainslider_' + this.props.name).slick('unslick');
    $('.navslider_' + this.props.name).slick('unslick');

    for (var i=0; i<PcConfig.screen.preview.filters.length; i++) this.mainSlides[i] = React.createRef();
    for (var i=0; i<PcConfig.screen.preview.filters.length; i++) this.navSlides[i] = React.createRef();
  }

  render()
  {
    if (this.props.active)
    {
      setTimeout( ()=> {
        this.reset();
      }, 10);
    }
    else {
      if (!this.props.keepState)
      {
        this.reseted = false;
        this.delete();
        return null;
      }
    }

    let slideWidth, navWidth;

    if (PcTemplates.template[this.props.template].size.height == 1800)
    {
      slideWidth = this.props.width * 0.55;
    }
    else {
      slideWidth = this.props.width * 0.7;
    }

    navWidth = this.props.width*0.9*PcConfig.screen.preview.filters.length/6;
    if (navWidth>this.props.width*0.9) navWidth = this.props.width*0.9;

    let foregrounds = [];

    if (this.props.animationMode=="photo")
    {
      foregrounds[0] = PcConfig.template.t15x10_1pose_full;
    }
    else
    {
      foregrounds[0] = PcConfig.template.t15x15_1pose_full_0;
      foregrounds[1] = PcConfig.template.t15x15_1pose_full_1;
      foregrounds[2] = PcConfig.template.t15x15_1pose_full_2;
      foregrounds[3] = PcConfig.template.t15x15_1pose_full_3;
    }

    let mainSlides = [];
    let navSlides = [];

    for (var i=0; i<PcConfig.screen.preview.filters.length; i++)
    {
      let index = i;

      mainSlides[i] = ((i)=>{return e('div',{className:"slick-item", key:"img"+i, onTouchEnd:()=>this.onTouchSlide(i), style:{height:this.props.height*0.7}},
                    e(PcPhoto,
                      {
                        ref:this.mainSlides[i],
                        animationMode:this.props.animationMode,
                        preview:false,
                        template:this.props.template,
                        filter:PcConfig.screen.preview.filters[i].filterName,
                        backgrounds : "",
                        foregrounds : foregrounds,
                        label:"",
                        width:slideWidth,
                        height:this.props.height*0.7,
                        padding:0,
                      }
                    )
                  );})(i);

      navSlides[i] = ((i)=>{ return e('div',{className:"slick-item-nav", key:"imgnav"+i, onTouchEnd:()=>this.onTouchSlide(i), style:{height:this.props.height*0.2}},
                    e(PcPhoto,
                      {
                        ref:this.navSlides[i],
                        animationMode:"photo",
                        preview:true,
                        template:this.props.template,
                        filter:PcConfig.screen.preview.filters[i].filterName,
                        backgrounds : "",
                        foregrounds : [""],
                        label:PcConfig.screen.preview.filters[i].title,
                        width:navWidth/PcConfig.screen.preview.filters.length - 20*PcConfig.renderSize,
                        height:this.props.height*0.2,
                        padding:10*PcConfig.renderSize,
                      }
                    )
                  );})(i);

    }

    return e('div',
        {
          className:"pcslidercontainer",
          style:
          {
            position:"absolute",
            opacity:0,
            animation:PcConfig.scenario.elementsAnimationStyle,
            animationFillMode:"forwards",
            animationDelay:this.props.showDelay,
            width:this.props.width,
            height:this.props.height,
            left:this.props.x,
            top:this.props.y,
            display:"table-cell",
            textAlign:"center"
          }
        },
        e('div', {className:"mainslider_"+this.props.name, style:{width:this.props.width, height:this.props.height*0.6}}, mainSlides),
        e('div', {style:{height:20*PcConfig.renderSize}}),
        e('div',
          {
            style:{width:this.props.width, height:this.props.height*0.3, display:"table-cell", textAlign:"center"}
          },
          e('div', {className:"navslider_"+this.props.name, style:{overflow:"visible", display:"inline-block", width:navWidth, height:this.props.height*0.3}}, navSlides)
        )
      );
  }
}
