class PcScreenFormat extends PcScreen
{
  constructor(props)
  {
    super(props);

    this.buttons = [];
    this.buttons["previous"] = React.createRef();
    this.buttons["next"] = React.createRef();

    this.registerButton(this.buttons["previous"], PcConfig.screen.format.previousButton.title);
    this.registerButton(this.buttons["next"], PcConfig.screen.format.nextButton.title);
  }

  normalizeButtons()
  {
    setTimeout(()=>{this.normalizeButtonsWidth()}, 10);
  }

  componentDidMount()
  {
      if (this.props.active) this.normalizeButtons();
  }

  componentDidUpdate()
  {
      if (this.props.active) this.normalizeButtons();
  }

  render()
  {
    if (!this.props.active) return null;

    return e('div',
      {
        className:this.state.className,
        index:this.props.index,
        style:
        {
          display: (this.props.active ? 'block' : 'none'),
          fontFamily:PcConfig.scenario.fontFamily,
          animation:this.props.noAnimation?"":this.state.animationStyle
        },
      },
      e(PcLabel,
        {
          label:PcConfig.screen.format.title,
          title:true,
          width:this.props.width*0.9,
          height:this.props.height*(0.1),
          x:this.props.width*0.05,
          y:this.props.height*(PcMode.screen.format.titleY),
          fontSize:PcConfig.scenario.fontSizeBig,
          color: PcConfig.scenario.fontColor,
          showDelay:"0,1s"
        }
      ),
      e(PcSliderFormats,
        {
          active: this.props.active,
          keepState: this.props.keepState,
          name:"formats",
          onSelectSlide:()=>this.props.goNextScreen(),
          x:0,
          y:this.props.height*(PcMode.screen.format.sliderY),
          width:this.props.width,
          height:this.props.height*(PcMode.screen.format.sliderH),
          showDelay:"0.2s"
        }
      ),
      e('div',
        {
          style:
            {
              position:"absolute",
              width:"100%",
              top:this.props.height * (PcMode.screen.format.buttonsY),
              display:"inline-flex",
              justifyContent: PcMode.screen.format.buttonsJustify,
            }
        },
        e(PcButton,
          {
            ref:this.buttons["previous"],
            label:PcConfig.screen.format.previousButton.title,
            fontColor:PcConfig.screen.format.previousButton.fontColor,
            borderColor:PcConfig.screen.format.previousButton.borderColor,
            backgroundColor:PcConfig.screen.format.previousButton.backgroundColor,
            prevArrow:true,
            align:"right",
            onClick:this.props.goPrevScreen,
            sound : PcConfig.sounds.buttonPrevious,
            showDelay:"0.3s"
          }
        ),
        e(PcButton,
          {
            ref:this.buttons["next"],
            label: PcConfig.screen.format.nextButton.title,
            fontColor:PcConfig.screen.format.nextButton.fontColor,
            borderColor:PcConfig.screen.format.nextButton.borderColor,
            backgroundColor:PcConfig.screen.format.nextButton.backgroundColor,
            animated : true,
            nextArrow:true,
            kind: "action",
            onClick:this.props.goNextScreen,
            sound : PcConfig.sounds.buttonNext,
            showDelay:"0.4s"
          }
        )
      )
    );
  }
}
