class PcDoc extends React.Component
{
  constructor(props)
  {
    super(props);
    this.iframe = React.createRef();
    this.iframeContainer = React.createRef();
    this.state = {label:props.label};
  }

  removeLinks(txt)
  {
    let newtxt = txt;

    do
    {
      txt = newtxt;
      newtxt = txt.replace(/<a\b[^>]*>/i,"").replace(/<\/a>/i, "");
    } while (newtxt != txt)

    return newtxt;
  }

  updateTextFile(textFile)
  {
    this.iframe.current.style.visibility="hidden";

    $.ajax({
      url: textFile,
      type: "GET",
      timeout:120000,
      dataType: "text",
      success: (data)=>{
        this.iframe.current.srcdoc = this.removeLinks(data);
        let size = PcConfig.renderSize;
        this.iframe.current.style.transformOrigin = "top left";
        this.iframe.current.style.transform = "scale("+size+")";
        this.iframe.current.style.width = this.iframeContainer.current.offsetWidth*1/size;
        this.iframe.current.style.height = this.iframeContainer.current.offsetHeight*1/size;
        this.iframe.current.style.visibility="visible";
      },
      error: (xhr, status, err)=>{
        //
      }
    });

  }

  render()
  {
    return e('div',
      {
        style:
        {
          display: (this.props.active ? 'block' : 'none'),
          position:"absolute",
          fontFamily:PcConfig.scenario.fontFamily,
          left: 0,
          top:0,
          width:"100%",
          height:"100%",
          backgroundColor:"rgba(0, 0, 0, 0.9)",
          }
      },
      e('div',
        {
          ref : this.iframeContainer,
          style:
            {
              position:"absolute",
              overflow:"hidden",
              width:"90%",
              height:"75%",
              top:"10%",
              left:"5%",
            }
        },
        e('iframe',
          {
            ref:this.iframe,
            src:"_blank",
            sandbox:"",
            style:
            {
              position:"absolute",
              top:0,
              left:0,
              backgroundColor:"#fff",
            }
          }
        )
      ),
      e('div',
        {
          style:{width:'100%', height:50*PcConfig.renderSize}
        }
      ),
      e('div',
        {
          style:
            {
              position:"absolute",
              width:"100%",
              height:"15%",
              top:"85%",
              display:"inline-flex",
              justifyContent: "center",
              flexWrap: "wrap",
              alignContent:"center",
            }
        },
        e(PcButton,
          {
            label:"ok",
            onClick:this.props.onClickButton,
            //sound : PcConfig.sounds.button,
            fontColor:"#000000",
            borderColor:"#FFFFFF",
            backgroundColor:"#FFFFFF",
            showDelay:"0.2s"
          }
        )
      )
    );
  }
}
