class PcOptin extends React.Component
{
  constructor(props)
  {
    super(props);
    this.labelObj = React.createRef();
    this.labelContainer = React.createRef();
    this.answer = -1;

    this.state =
    {
      colorYes:PcConfig.scenario.standardButtonBackgroundColor,
      colorNo:PcConfig.scenario.standardButtonBackgroundColor
    }
  }

  getStringWidth(text, font, size)
  {
    var div = document.createElement('span');
    div.style.position = "absolute";
    div.style.display = "inline";
    div.style.fontFamily = font;
    div.style.fontSize = size;
    div.style.color = "#ffffff";
    div.textContent = text;

    document.body.appendChild(div);
    var width = div.getBoundingClientRect().width;
    document.body.removeChild(div);

    return width;
  }

  getWidth()
  {
    return this.labelContainer.current.offsetWidth + parseFloat(this.labelContainer.current.style.marginLeft) + parseFloat(this.labelContainer.current.style.marginRight);
  }

  onClick(val)
  {
    if (val=="yes")
    {
      this.answer = 1;
      this.setState(
        {
          colorYes:PcConfig.scenario.standardButtonBorderColor,
          colorNo:PcConfig.scenario.standardButtonBackgroundColor
      });
    }
    else if (val=="no")
    {
      this.answer = 0;
      this.setState(
        {
          colorYes:PcConfig.scenario.standardButtonBackgroundColor,
          colorNo:PcConfig.scenario.standardButtonBorderColor
      });
    }
    else
    {
      this.answer = -1;
      this.setState(
        {
          colorYes:PcConfig.scenario.standardButtonBackgroundColor,
          colorNo:PcConfig.scenario.standardButtonBackgroundColor
      });
    }

    this.props.answered(this.answer);
  }

  reset()
  {
    this.onClick("");
  }

  render()
  {
    var width, height;
    var valign, halign;
    var x, y;
    var position;

    this.props.width ? (width = this.props.width) : (width="auto");
    this.props.height ? (height = this.props.height) : (height="auto");
    this.props.valign ? (valign = this.props.valign) : (valign="middle");
    this.props.halign ? (halign = this.props.halign) : (halign="center");
    this.props.x ? (x = this.props.x) : (x=0);
    this.props.y ? (y = this.props.y) : (y=0);
    this.props.position ? (position = this.props.position) : (position="absolute");

    return e('div',
      {
        className:"pclabelcontainer",
        ref:this.labelContainer,
        style:
        {
          display:"table",
          position:position,
          opacity:this.props.noAnimation?1:0,
          animation:this.props.noAnimation?"":PcConfig.scenario.elementsAnimationStyle,
          animationFillMode:"forwards",
          animationDelay:this.props.showDelay,
          left:this.props.x,
          top:this.props.y,
          width:this.props.width,
          height:this.props.height,
        }
      },
      e('div', {style:{width:"100%", height:20*PcConfig.renderSize}}),
      e(PcLabel,
        {
          label:this.props.label,
          position:"relative",
          width:"100%",
          x:0,
          y:0,
          fontSize:this.props.fontSize,
          color: this.props.color,
          halign:this.props.halign,
          showDelay:"0,1s"
        }
      ),
      e('div', {style:{width:"100%", height:15*PcConfig.renderSize}}),
      e('div',
       {
         onClick:()=>{PcConfig.sounds.button.play(); this.onClick("yes")},
         style:
         {
           borderStyle:"solid",
           borderWidth:PcConfig.scenario.buttonsBorderWidth/1.5,
           borderColor:PcConfig.scenario.standardButtonBorderColor,
           backgroundColor:this.state.colorYes,
           borderRadius:"50%",
           width:22*PcConfig.renderSize,
           height:22*PcConfig.renderSize,
           display:"inline-block",
           verticalAlign:"middle",
         }
       }
      ),
      e('label',
        {
          onClick:()=>{PcConfig.sounds.button.play(); this.onClick("yes")},
          style:
            {
              fontFamily:PcConfig.scenario.fontFamily,
              fontSize:this.props.fontSize,
              color: this.props.color,
              display:"inline-block",
              verticalAlign:"middle",
              paddingLeft:10*PcConfig.renderSize,
            },
        },
        "Oui"
      ),
      e('div', {style:{width:40*PcConfig.renderSize, display:"inline-block", verticalAlign:"middle"}}),
      e('div',
       {
         onClick:()=>{PcConfig.sounds.button.play(); this.onClick("no")},
         style:
         {
           borderStyle:"solid",
           borderWidth:PcConfig.scenario.buttonsBorderWidth/1.5,
           borderColor:PcConfig.scenario.standardButtonBorderColor,
           backgroundColor:this.state.colorNo,
           borderRadius:"50%",
           width:22*PcConfig.renderSize,
           height:22*PcConfig.renderSize,
           display:"inline-block",
           verticalAlign:"middle",
         }
       }
      ),
      e('label',
        {
          onClick:()=>{PcConfig.sounds.button.play(); this.onClick("no")},
          style:
            {
              fontFamily:PcConfig.scenario.fontFamily,
              fontSize:this.props.fontSize,
              color: this.props.color,
              display:"inline-block",
              verticalAlign:"middle",
              paddingLeft:10*PcConfig.renderSize,
            },
        },
        "Non"
      ),
      e('div', {style:{width:"100%", height:20*PcConfig.renderSize}}),
    );
  }

}
