class PcForm extends React.Component
{
  constructor(props)
  {
    super(props);

    this.initialized = false;

    this.keyboard = React.createRef();

    this.formContainer = React.createRef();
    this.formElements = React.createRef();

    this.email = React.createRef();

    this.questions = [];
    for (let i=0; i<PcConfig.screen.infos.questions.length; i++) this.questions[i] = React.createRef();

    this.positions = [];
    this.elements = [];
    this.showKeyboard = [];
    this.showKeyboardId = [];
    this.keyboardKind = [];
    this.keyboardUppercase = [];
    this.currentElement = 0;
    this.positionWithoutKeyboard = PcMode.screen.infos.formPositionWithoutKeyboard*PcConfig.renderSize;
    this.positionWithKeyboard = PcMode.screen.infos.formPositionWithKeyboard*PcConfig.renderSize;
    this.positionWithKeyboardId = PcMode.screen.infos.formPositionWithKeyboardId*PcConfig.renderSize;

    this.nextButtonLabel = PcConfig.screen.infos.nextButton.title;
    this.nextButtonValidateLabel = PcConfig.screen.infos.nextButton.titleValidate;

    this.state = {keyboardKind:"email"};
  }

  componentDidMount()
  {
    if (this.props.active) this.initialize();
  }

  componentDidUpdate()
  {
    if (this.props.active) this.initialize();
  }

  initialize()
  {
    if (this.initialized) return;

    let showKeyboard, keyboardType, keyboardUppercase;
    var ind = 0;

    for (let i=0; i<this.questions.length; i++)
    {
      switch (PcConfig.screen.infos.questions[i].kind)
      {
        case "email" : showKeyboard=true; keyboardType="email"; break;
        case "listing" : showKeyboard=true; keyboardType="text"; break;
        case "uniqChoice" : showKeyboard=false; keyboardType=""; break;
        case "multipleChoice" : showKeyboard=false; keyboardType=""; break;
        case "number" : showKeyboard=true; keyboardType="number"; break;
        case "text" : showKeyboard=true; keyboardType="text"; break;
        case "prints" : showKeyboard=false; keyboardType=""; break;
      }

      if (PcConfig.screen.infos.questions[i].kind=="prints" && PcConfig.screen.format.formats[PcConfig.getMemory("currentFormatIndex")].printing==false)
      {
        //do nothing
      }
      else {
        this.elements[ind] = this.questions[i];
        this.showKeyboard[ind] = showKeyboard;
        this.showKeyboardId[ind] = (PcConfig.screen.infos.questions[i].kind=="listing");
        this.keyboardKind[ind] = keyboardType;
        this.keyboardUppercase[ind] = PcConfig.screen.infos.questions[i].uppercase;
        ind++;
      }
    }

    for (let i=0; i<this.elements.length; i++)
    {
      this.positions[i] = ReactDOM.findDOMNode(this.elements[i].current).offsetTop;
    }

    this.keyboard.current.hide();

    this.refreshElements();

    this.initialized = true;
  }

  refreshElements()
  {
    if (this.showKeyboard[this.currentElement])
    {
      if (this.showKeyboardId[this.currentElement])
      {
        ReactDOM.findDOMNode(this.formElements.current).style.top = (this.positionWithKeyboardId - this.positions[this.currentElement]) + "px";
      }
      else {
        ReactDOM.findDOMNode(this.formElements.current).style.top = (this.positionWithKeyboard - this.positions[this.currentElement]) + "px";
      }

      for (let i=0; i<this.elements.length; i++)
      {
        ReactDOM.findDOMNode(this.elements[i].current).style.opacity = (i==this.currentElement) ? 1 : 0;
      }

      setTimeout( () => {
        ReactDOM.findDOMNode(this).focus();
        this.elements[this.currentElement].current.setFocus();
        this.elements[this.currentElement].current.onKeyPressed("");
      }, 500);

      this.setState({keyboardKind:this.keyboardKind[this.currentElement], keyboardUppercase:this.keyboardUppercase[this.currentElement]});
      this.keyboard.current.show();
    }
    else {
      ReactDOM.findDOMNode(this.formElements.current).style.top = (this.positionWithoutKeyboard - this.positions[this.currentElement]) + "px";

      for (let i=0; i<this.elements.length; i++)
      {
        ReactDOM.findDOMNode(this.elements[i].current).style.opacity = 1/(Math.pow((Math.abs(i-this.currentElement)*1.5), 2)+1);
      }

      this.keyboard.current.hide();
    }

    for (let i=0; i<this.elements.length; i++) this.elements[i].current.focused = false;
    this.elements[this.currentElement].current.focused = true;
  }

  emailInputSwitchMode(mode, index)
  {
    console.log("email input switch mode");
    if (mode=="email")
    {
      this.showKeyboardId[index] = false;
      this.keyboardKind[index]="email";
    }
    else
    {
      this.showKeyboardId[index] = true;
      this.keyboardKind[index]="text";
    }

    this.refreshElements();
  }

  emailInputSkip()
  {
    this.props.forceNext();
  }

  reset()
  {
    this.currentElement = 0;

    for (let i=0; i<this.elements.length; i++)
    {
      this.elements[i].current.reset();
    }

    this.refreshElements();
  }

  goPrevious()
  {
    this.currentElement--;

    //CREDIT AGRICOLE EXCEPTION
    if (PcConfig.global.name.indexOf("CREDIT AGRICOLE ID")!=-1)
    {
      if (this.currentElement==1)
      {
        let q = PcConfig.getMemory("question"+0);
        if (q.indexOf("nouveau badge")!=-1 || q.indexOf("new badge")!=-1)
        {
           PcConfig.setMemory("question1", "");
           this.goPrevious();
           //this.currentElement--;
        }
      }
    }
    //

    this.refreshElements();
  }

  goNext()
  {
    if (this.currentElement+1>=this.elements.length) return true;

    this.currentElement++;

    //CREDIT AGRICOLE EXCEPTION
    if (PcConfig.global.name.indexOf("CREDIT AGRICOLE ID")!=-1)
    {
      if (this.currentElement==1)
      {
        let q = PcConfig.getMemory("question"+0);
        if (q.indexOf("nouveau badge")!=-1 || q.indexOf("new badge")!=-1)
        {
           PcConfig.setMemory("question1", "");
           //this.currentElement++;
           this.goNext();
        }
      }
    }
    //

    this.refreshElements();

    return false;
  }

  onClickFormElement(n)
  {
    if (this.currentElement==n) return;

    console.log("formelement " + n);

    if (n<this.currentElement)
    {
      this.props.clickPrevious();
    }else {
      this.props.clickNext();
    }
  }

  onClickOkButton()
  {
    this.props.clickNext();
  }

  getNextButton()
  {
    if (this.currentElement>=this.elements.length-1)
    {
      return {title:this.nextButtonValidateLabel, nextArrow:false};
    } else {
      return {title:this.nextButtonLabel, nextArrow:true};
    }
  }

  onKeyPressed(key)
  {
    if (!this.initialized) return;
    if (!this.elements[this.currentElement].current || !this.elements[this.currentElement].current.onKeyPressed) return;
    this.elements[this.currentElement].current.onKeyPressed(key);
  }

  onAnsweredEmail(value)
  {
    console.log("answered email", value);

    if (value=="") return;
    PcConfig.setMemory('email', value);

    var id = PcConfig.getMemory("currentId");

    if (id)
    {
      this.elements[1].current.setValue(id[3]);
      this.elements[2].current.setValue(id[1]);
      this.elements[3].current.setValue(id[2]);
    }
    else {
      this.elements[1].current.setValue("");
      this.elements[2].current.setValue("");
      this.elements[3].current.setValue("");
    }
  }

  onAnsweredOptin(index, value)
  {
    var val;

    if (value=="Yes" || value==1)
    {
      val = 1;
    } else if (value=="No"  || value==0)
    {
      val = 0;
    }
    else {
      val = -1;
    }

    PcConfig.setMemory('question'+index, value);
  }

  onAnsweredQuestion(index, value)
  {
    if (value=="") return;
    PcConfig.setMemory('question'+index, value);

    if (PcConfig.screen.infos.questions[index].kind=="prints")
    {
      PcConfig.setMemory("prints", Number(value));
    }

    if (PcConfig.screen.infos.questions[index].kind=="listing")
    {
        let idData = PcConfig.getMemory("currentId");
        console.log("idData", idData);

        for (let i=0; i<PcConfig.screen.infos.questions.length; i++)
        {
          let prefill = PcConfig.screen.infos.questions[i].prefill;
          if (prefill!="" && prefill>0)
          {
            if (idData!="")
            {
              this.elements[i].current.setValue(idData[prefill-1]);
            }
            else {
              this.elements[i].current.setValue("");
            }
          }
        }
    }

  }

  onClickChoiceDoc(textFile)
  {
    if (this.props.onClickFormDoc) this.props.onClickFormDoc(textFile);
  }

  validate()
  {
    return this.elements[this.currentElement].current.validate();
  }

  render()
  {
    if (!this.props.active) return null;

    var index=0;

    const formQuestions = PcConfig.screen.infos.questions.map( (item)=> {
      let index=item.index;
      let elementClass = null;
      let showKeyboard;
      let keyboardType;
      let keyboardUppercase = false;

      switch (item.kind)
      {
        case "email" : elementClass = PcFormEmail; showKeyboard=true; keyboardType="email"; break;
        case "listing" : elementClass = PcFormEmail; showKeyboard=true; keyboardType="text"; break;
        case "uniqChoice" : elementClass = PcFormChoice; showKeyboard=false; keyboardType=""; break;
        case "multipleChoice" : elementClass = PcFormChoice; showKeyboard=false; keyboardType=""; break;
        case "number" : elementClass = PcFormNumber; showKeyboard=true; keyboardType="number"; break;
        case "text" : elementClass = PcFormText; showKeyboard=true; keyboardType="text"; keyboardUppercase = item.uppercase; break;
        case "prints" : elementClass = PcFormChoice; showKeyboard=false; keyboardType=""; break;
        default: elementClass = PcFormText; showKeyboard=true; keyboardType="text"; break;
      }

      if (item.kind=="prints" && PcConfig.screen.format.formats[PcConfig.getMemory("currentFormatIndex")].printing==false)
      {
        //do nothing
      }
      else
      {
        return e(elementClass,
          {
            key:index,
            ref:this.questions[item.index],
            onClick:(e)=>this.onClickFormElement(index),
            okClick:()=>this.onClickOkButton(),
            onClickChoiceDoc:()=>this.onClickChoiceDoc(item.doc),
            kind:item.kind,
            answered:(value)=>this.onAnsweredQuestion(item.index, value),
            emailInputSwitchMode:(kind)=>this.emailInputSwitchMode(kind, index),
            emailInputSkip:()=>this.emailInputSkip(),
            errorMessageEmail:PcConfig.screen.infos.questions[item.index].error,//"Erreur email en dur",
            errorMessageId:PcConfig.screen.infos.questions[item.index].error,
            required:PcConfig.screen.infos.questions[item.index].required,
            listingFile:PcConfig.screen.infos.questions[item.index].file,
            listingText:PcConfig.screen.infos.textListing,
            docFile:PcConfig.screen.infos.questions[item.index].doc,
            showKeyboard:showKeyboard,
            keyboardType:keyboardType,
            keyboardUppercase:keyboardUppercase,
            active:this.props.active,
            label:item.label,
            mention:item.mention,
            type : item.kind,
            choices:item.choices,
            multipleChoices : item.kind=="multipleChoice" ? true : false,
            min:item.min,
            max:item.max,
            errorMessage:item.error,
            width:"100%",
            position:"relative",
            fontSize:PcConfig.scenario.fontSize,
            color: PcConfig.scenario.textColor,
            centered:this.props.centered,
            halign:"left",
            showDelay:"0,1s"
          }
        );
      }
    });

    return e('div',
      {
        style:
          {
            position:"absolute",
            width:"100%",
            top:0,
            left:0,
            height:"100%",
          }
      },
        e('div',
        {
          ref:this.formContainer,
          style:
            {
              position:"absolute",
              width:this.props.width,
              top:this.props.top,
              left:this.props.left,
              height:this.props.height,
              overflow:"hidden",
              //backgroundColor:"#ff0000"
            }
        },
          e('div',
            {
              ref:this.formElements,
              style:
              {
                position:"absolute",
                width:this.props.width,
                height:this.props.height,
                transition:"all 0.25s ease-out",
              }
            },
            formQuestions
          )
        ),
      e(PcKeyboard,
        {
          ref:this.keyboard,
          kind:this.state.keyboardKind,
          uppercase:this.state.keyboardUppercase,
          onKeyPressed:(key)=>this.onKeyPressed(key),
          x:this.props.left,
          y:this.props.height*PcMode.screen.infos.formKeyboardY,
          width:this.props.width,
          height:this.props.height*PcMode.screen.infos.formKeyboardH,
          fontSize:PcConfig.scenario.fontSizeBig,
          color: PcConfig.scenario.keyboardTextColor,
          backgroundColor: PcConfig.scenario.keyboardBackgroundColor,
          showDelay:"0,1s"
        }
      )
    );
  }

}
