class PcFormChoiceButton extends React.Component
{
  static get test() {return "test"}

  constructor(props)
  {
    super(props);
    this.state =
      {
        width:props.width,
        padHorizontal:32,
        padVertical:16,
      }

    this.buttonBackground = React.createRef();
    this.buttonContainer = React.createRef();
    this.selected = false;
  }

  static predictSize(label)
  {
    var e = document.createElement("canvas");
    var ctx = e.getContext("2d");
    ctx.font = PcConfig.scenario.fontSize + " " + PcConfig.scenario.fontFamily;
    var t= ctx.measureText(label);
    return t.width;
  }

  getWidth()
  {
    return this.buttonBackground.current.getBoundingClientRect().width;
  }

  setWidth(w)
  {
    this.setState({width: w-(2*this.state.padHorizontal*PcConfig.renderSize)-2*PcConfig.scenario.buttonsBorderWidth});
  }

  select()
  {
    this.selected = true;
    this.forceUpdate();
  }

  unselect()
  {
    this.selected = false;
    this.forceUpdate();
  }

  isSelected()
  {
    return this.selected;
  }

  onClick(e)
  {
    if (e.type === 'touchend')
    {
      e.preventDefault();
      if (e.targetTouches.length>0) return;
    }

    if (this.props.sound) this.props.sound.play();
    if (this.props.onClick) this.props.onClick();
  }

  render()
  {
    if (this.selected == false)
    {
      var borderColor = PcConfig.scenario.actionButtonBorderColor;
      var backgroundColor = PcConfig.scenario.actionButtonBackgroundColor;
      var textColor = PcConfig.scenario.actionButtonTextColor;
    }
    else {
      var borderColor = PcConfig.scenario.actionButtonBackgroundColor;
      var backgroundColor = PcConfig.scenario.actionButtonTextColor;
      var textColor = PcConfig.scenario.actionButtonBackgroundColor;
    }

    if (PcConfig.scenario.buttonsStyle=="rounded")
    {
      var borderRadius = 12 * PcConfig.renderSize;
    }
    else
    {
      var borderRadius = 0;
    }

    return e('div',
        {
          className:"pcchoicebuttoncontainer",
          ref:this.buttonContainer,
          style:
          {
            opacity:0,
            animation:PcConfig.scenario.elementsAnimationStyle,
            animationDelay:this.props.showDelay,
            left: this.props.x,
            top:this.props.y,
            marginLeft: this.props.spacingHLeft,
            marginRight: this.props.spacingHRight,
            marginTop: this.props.spacingV,
            marginBottom: this.props.spacingV
          }
        },
        e('div',
          {
            className:"pcchoicebutton",
            ref:this.buttonBackground,
            style:
              {
                position:"relative",
                width:this.state.width,
                height:this.props.height,
                borderStyle:"solid",
                borderWidth:PcConfig.scenario.buttonsBorderWidth/2,
                borderColor:borderColor,
                backgroundColor:backgroundColor,
                borderRadius:borderRadius,
                paddingTop:this.state.padVertical*PcConfig.renderSize,
                paddingBottom:this.state.padVertical*PcConfig.renderSize,
                paddingLeft:this.state.padHorizontal*PcConfig.renderSize,
                paddingRight:this.state.padHorizontal*PcConfig.renderSize,
                overflow:"auto",
                fontFamily:PcConfig.scenario.fontFamily,
                fontSize:PcConfig.scenario.fontSizeMedium,
                color:textColor,
                verticalAlign: "middle",
                textAlign: "center"
              },
              onClick:(e)=>{this.onClick(e)},
              onTouchEnd:(e)=>{this.onClick(e)},
              dangerouslySetInnerHTML:{__html:this.props.label}
          }
        )
    );
  }
}
