<?php
include_once 'config.php';
define('RETENTION_DELAY_SECONDS', 30 * ONE_DAY_IN_SECONDS);
define('COMMONDBG', false);

function get_cabin_status($db, $xml)
{
    $sql  = 'SELECT * from photocabine_status WHERE (config = \''. $xml->id . '\' AND device = ' . DEVICE_ID . ') ORDER BY date DESC LIMIT 0, 1';
    $line = $db->select($sql);

    dbg(COMMONDBG, "get_cabin_status req: $sql gave %s", json_encode($line));
    return $line;

}
function get_retention_deadline($db, $xml)
{
 $line = get_cabin_status($db, $xml);

 $deadline = time(); // now

 if ($line) {
     $deadline = $line->retention_deadline;
 } 

 return $deadline;

}
function get_retention_delay_seconds($xml)
{

    $some_vars_set = 0;
    $ret = 0;
    dbg(RETENTIONDBG, "isset: " .  isset($xml->general->configuration->retentionDelayEnable) . " " .  isset($xml->general->configuration->retentionDelayDays) . " " . isset($xml->general->configuration->retentionDelayHours) . " " . isset($xml->general->configuration->retentionDelayMinutes));
    dbg(RETENTIONDBG, "retention values: enable: " .  $xml->general->configuration->retentionDelayEnable . " days: " .  $xml->general->configuration->retentionDelayDays . " hours: " . $xml->general->configuration->retentionDelayHours . "  minutes: " . $xml->general->configuration->retentionDelayMinutes);

    if (
        isset($xml->general->configuration->retentionDelayEnable)
        && ($xml->general->configuration->retentionDelayEnable == 1)
    ) {
        if (isset($xml->general->configuration->retentionDelayDays)) {
            $some_vars_set = 1;
            $ret += $xml->general->configuration->retentionDelayDays * ONE_DAY_IN_SECONDS;
        }
        if (isset($xml->general->configuration->retentionDelayHours)) {
            $some_vars_set = 1;
            $ret += $xml->general->configuration->retentionDelayHours * ONE_HOUR_IN_SECONDS;
        }
        if (isset($xml->general->configuration->retentionDelayMinutes)) {
            $some_vars_set = 1;
            $ret += $xml->general->configuration->retentionDelayMinutes * ONE_MINUTE_IN_SECONDS;
        }

        dbg(RETENTIONDBG, "total xml retention: " . $ret);
    }
    if ($some_vars_set == 0) {
        dbg(RETENTIONDBG, "fallback to hardcoded 30 days values:" . RETENTION_DELAY_SECONDS . " " . ONE_DAY_IN_SECONDS);
        $ret = RETENTION_DELAY_SECONDS;
    }

    dbg(RETENTIONDBG, "final value: " . $ret);
    return $ret;
}
